/* -*-Java-*- */

package mpi;

import pl.edu.agh.icsr.janet.tools.*;

public class File extends DataEncapsulator {
native "C" {
#include <mpi.h>
#include <mpio.h>
}

    public final static int MODE_RDONLY          =    2;  /* ADIO_RDONLY */
    public final static int MODE_RDWR            =    8;  /* ADIO_RDWR  */
    public final static int MODE_WRONLY          =    4;  /* ADIO_WRONLY  */
    public final static int MODE_CREATE          =    1;  /* ADIO_CREATE */ 
    public final static int MODE_EXCL            =   64;  /* ADIO_EXCL */
    public final static int MODE_DELETE_ON_CLOSE =   16;  /* ADIO_DELETE_ON_CLOSE */
    public final static int MODE_UNIQUE_OPEN     =   32;  /* ADIO_UNIQUE_OPEN */
    public final static int MODE_APPEND          =  128;  /* ADIO_APPEND */
    public final static int MODE_SEQUENTIAL      =  256;  /* ADIO_SEQUENTIAL */

  public File() {
  }

  public native "C" int open(Comm comm, String filename, int amode,
			     Info info) {
      MPI_File f = (MPI_File)`this.data`;
      MPI_Info info = `info != null` ? `info.data` : MPI_INFO_NULL;
      int result;
      result = MPI_File_open((MPI_Comm)`comm.handle`, (char*)`#&filename`, `amode`,
			     info, &f);
      `this.data = #(f);`
      return result;
  }

  public native "C" int preallocate(long size) {
    return MPI_File_preallocate((MPI_File)`this.data`, (MPI_Offset)`size`);
  }

  public native "C" int set_view(long disp, Datatype etype, Datatype filetype,
				 String datarep, Info info) {
      MPI_Info info = `info != null` ? `info.data` : MPI_INFO_NULL;
      return MPI_File_set_view((MPI_File)`this.data`, (MPI_Offset)`disp`, 
			       (MPI_Datatype)`etype.handle`, (MPI_Datatype)`filetype.handle`,
			       (char*)`#&datarep`, info);
  }

  public native "C" int read_at(long offset, VDouble buf, int count,
				Datatype datatype, Status status) {
    void* buf = (`&buf.getBaseArray()` + `buf.getOffset()`);
    return MPI_File_read_at((MPI_File)`this.data`, (MPI_Offset)`offset`, buf, `count`,
			    (MPI_Datatype)`datatype.handle`, (MPI_Status*)`status.handle`);
  }

  public native "C" int write_at(long offset, VDouble buf, int count,
				 Datatype datatype, Status status) {
    void* buf = (`&buf.getBaseArray()` + `buf.getOffset()`);
    return MPI_File_write_at((MPI_File)`this.data`, (MPI_Offset)`offset`, buf, `count`,
			     (MPI_Datatype)`datatype.handle`, (MPI_Status*)`status.handle`);
  }

  public native "C" int close() {
    MPI_File f = (MPI_File)`this.data`;
    int result = MPI_File_close(&f);
    `this.data = #(f);`
    return result;
  }
  

  protected native void freeNative() {
    MPI_File file = (MPI_File)`this.data`;
    if (file) MPI_File_close(&file);
    `this.data = #(file)`;
  }
  
}
