/* -*-Java-*- */

package pl.edu.agh.icsr.lip;

import mpi.*;
import pl.edu.agh.icsr.janet.tools.*;

public class IOBufmap extends DataEncapsulator {
native "C" {
#include <lip.h>
#include <mpi.h>
#include <mpio.h>
}
  private static long IOBUFMAP_NULL = 0;
  
  public long getNullValue() { return IOBUFMAP_NULL; }

  public IOBufmap(int size) {
    init(size);
  }

  private native "C" void init(int size) {
    LIP_IOBufmap m;
    int result;
    result = LIP_IOBufmap_create(`size`, &m);
    `this.data = #(m)`;
    if (result != LIP_SUCCESS) `throw new LipException(#(result));`
  }

  public native "C" IndicesDatatypes get_datatype(mpi.Datatype datatype, int flags) {
    MPI_Datatype memtype;
    MPI_Datatype filetype;
    int result = LIP_IOBufmap_get_datatype((LIP_IOBufmap)`this.data`,
					   (MPI_Datatype)`datatype.handle`,
					   &memtype, &filetype, `flags`);
    if (result != LIP_SUCCESS) `throw new LipException(#(result));`

    /* FIXME: new Datatype from native one */
    `mpi.Datatype d1 = new mpi.Datatype(mpi.Datatype.DOUBLE);`
    `mpi.Datatype d2 = new mpi.Datatype(mpi.Datatype.DOUBLE);`
    `d1.handle = #(memtype);`
    `d2.handle = #(filetype);`
    return `new IndicesDatatypes(d1, d2)`;
  }

  public native "C" void free() {
    LIP_IOBufmap m = (LIP_IOBufmap)`this.data`;
    int result = LIP_IOBufmap_free(&m);
    `this.data = #(m);`
  }

  protected void freeNative() {
    if (data != getNullValue()) free();
  }
}


