/* -*-Java-*- */

package pl.edu.agh.icsr.lip;

import pl.edu.agh.icsr.janet.tools.*;

public class Schedule extends DataEncapsulator {
native "C" {
#include <lip.h>
#include <mpi.h>
#include <mpio.h>
}
  private static long SCHEDULE_NULL = 0;
  
  public long getNullValue() { return SCHEDULE_NULL; }

  public Schedule(int size) {
    init(size);
  }

  private native "C" void init(int size) {
    LIP_Schedule s;
    int result;
    result = LIP_Schedule_create(`size`, &s);
    `this.data = #(s)`;
    if (result != LIP_SUCCESS) `throw new LipException(#(result));`
  }

  public native "C" void commit() {
    LIP_Schedule s = (LIP_Schedule)`this.data`;
    int result = LIP_Schedule_commit(&s);
    `this.data = #(s);`
    if (result != LIP_SUCCESS) `throw new LipException(#(result));`
  }

  public native "C" void free() {
    LIP_Schedule s = (LIP_Schedule)`this.data`;
    int result = LIP_Schedule_free(&s);
    `this.data = #(s);`
    if (result != LIP_SUCCESS) `throw new LipException(#(result));`
  }

  protected void freeNative() {
    if (data != getNullValue()) free();
  }
}
