/*
LIP Library
created by Maciej Malawski
FIXME: This is only temporary sorting algorithm and should be replaced 
by something more adequate!
*/

#include <stdio.h>
#define M 7
#define NSTACK 50
#define FM 7875
#define FA 211
#define FC 1663
/*  Here M is the size of subarrays sorted by straight insertion and
NSTACK is the required auxillary storage, and the remaining constants
are used by the random number generating statements.                  */



void hashsort(int n, int * m_arr1, int * m_arr2)
                                                                      /*
8.4 QUICKSORT.

VERSION  1 04/Sept/92 Krakow updated by Tomasz Twardowski
modified by Maciej Malawski


Sorts an array arr1[0..n-1] into ascending numerical order using the
Quicksort algorithm. n is input; arr1 and arr2 are replaced on output by their
sorted rearangement.
Elements of arr2 are moved in the same order as arr1.

                                                  */
{
int      l = 1, jstack = 0, j, ir, iq, i;
int      istack[NSTACK+1];
long int
         fx = 0L;
int      a1, a2;
int      *arr1, *arr2;
                                                                      /*
------------------------------------------ QCKSRT - BEGIN ----------- */

    arr1 = m_arr1;
    arr2 = m_arr2;
    ir = n;
                                                                      /*
1. SORT BY STRAIGHT INSERTION.
                                                                      */
    for (; ; )
    {
       if (ir - l < M)
       {
          for (j = l + 1; j <= ir; j++)
          {
             a1 = arr1[j-1];
             a2 = arr2[j-1];
             for (i = j - 1; arr1[i-1] > a1 && i > 0; i--)
             {
                arr1[i] = arr1[i-1];
                arr2[i] = arr2[i-1];
             }   
             arr1[i] = a1;
             arr2[i] = a2;
          }
          if (jstack == 0)
             return;
          ir = istack[jstack--];
          l = istack[jstack--];
       }
       else
       {
          i = l;
          j = ir;
                                                                      /*
2. GENERATE A RANDOM INTEGER IQ BETWEEN L AND IR, INCLUSIVE.
                                                                      */
          fx = (fx * FA + FC) % FM;
          iq = l + ((ir - l + 1) * fx) / FM;
          a1 = arr1[iq-1];
          a2 = arr2[iq-1];
          arr1[iq-1] = arr1[l-1];
          arr2[iq-1] = arr2[l-1];
          for (; ; )
          {
             while (j > 0 && a1 < arr1[j-1])
                j--;
             if (j <= i)
             {
                arr1[i-1] = a1;
                arr2[i-1] = a2;
                break;
             }
             arr1[(i++)-1] = arr1[j-1];
             arr2[i-2] = arr2[j-1];
             while (a1 > arr1[i-1] && i <= n)
                i++;
             if (j <= i)
             {
                arr1[(i = j)-1] = a1;
                arr2[i-1] = a2;
                break;
             }
             arr1[(j--)-1] = arr1[i-1];
             arr2[j] = arr2[i-1];
          }
          if (ir - i >= i - l)
          {
             istack[++jstack] = i + 1;
             istack[++jstack] = ir;
             ir = i - 1;
          }
          else
          {
             istack[++jstack] = l;
             istack[++jstack] = i - 1;
             l = i + 1;
          }
          if (jstack > NSTACK)
             printf("NSTACK too small in QCKSRT");
       }
    }
                                                                      /*
------------------------------------------ QCKSRT - END ------------- */
} 

#undef M
#undef NSTACK
#undef FM
#undef FA
#undef FC
